package com.eactive.eai.batch.job.jobItem.ssnet;

import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.util.HashMap;

import com.eactive.eai.batch.common.LogUtil;
import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobHandle.JobProcessData;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;
import com.eactive.eai.batch.running.BatchOpenFileManager;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_SSNBT_0320 extends DefaultTelegram implements TelegramService
{

	private FileInputStream fin ;
    private int SEQUENCE_NO;
    private int REAL_BYTE;         //실 data byte수
    private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이

    private byte[] fileData;

    /**
     * 생성자
     */
    public SEND_SSNBT_0320() {
        //DATA송신
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
            boolean result = setBlockAndSeqNO();
            if (!result) {
                return false;
            }
            result = calculateSendLength();
            if (!result) return false;

            //전송길이 - 아데나 장비와 TCP통신을 위한 전문길이 필드
            compileField(0, "" + SEND_LENGTH, this.al_FieldProps[0]);

            //TRANSACTION CODE
            //- 신/구 고객을 구분하기 위한 코드
            //- 기존고객코드 : EG01, EG05(구버젼 IBM tr id)
            //- EG01,EG05를 제외하고는 모두 신규고객(Space처리)
            //compileField(1, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[1]);
            compileField(1, "", this.al_FieldProps[1]);

            //전문종별코드. 전문기능을 나타내는 코드 ('0600'/'0610')
            compileField(2, this.getFldTelegramType(), this.al_FieldProps[2]);

            //응답코드 : 전문의 처리결과를 나타내는 코드로 REQUEST전문에는 '0' 을 SET 하며
            //RESPONSE 전문에는 해당내용을 SET 한다.
            //'000' = 정상 '310' = 송신자 계정오류 '001' = 송신집계오류
            //'320' = 송신자 ID 오류 '330' = 송신자 PSWD오류 '010' = NUMERIC오류
            //'340' = 수신자계정오류 '350' = 수산자 ID오류 '999' = 기타오류
            compileField(3, this.getResolveResponseCode(), this.al_FieldProps[3]);

            //고객코드 - 현재 space 처리
            compileField(4, "", this.al_FieldProps[4]);

            //전문길이 - 순수 DATA의 길이
            compileField(5, ""+REAL_BYTE, this.al_FieldProps[5]);

            //전문일련번호 - DATA RECORD : '00000001'부터 1씩 증가
            compileField(7, "" + SEQUENCE_NO, this.al_FieldProps[7]);

            //송수신 업무구분 - 'S' : 송신, 'R' : 수신
            compileField(8, TelegramKeys.SSNET_SEND, this.al_FieldProps[8]);

            //<< 전문 완성

            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    public int getInformalFieldSendData(int idx, byte[] data) {
        int fldLen = getCalculatedLength(idx);
        if ( fldLen == 0 ){
        	return 0;
        }
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < fldLen) {
                logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            ByteArrayInputStream bin = new ByteArrayInputStream(fileData);
            bin.read(data, 0, REAL_BYTE);
            for (int inx = REAL_BYTE; inx < fldLen; inx++) {
                data[inx] = ' ';
            }

            // 로깅을 위해
            byte[] fieldData = new byte[fldLen];
            System.arraycopy(data, 0, fieldData, 0, fldLen);
            this.al_Field.set( idx, fieldData);

            return fldLen;

        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }

    public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;

            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<5; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=5; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize() + REAL_BYTE;
            batchDoc.getBatchMsg().getBody().setCurFileSize(lnCurSize);
            if ( lnCurSize == REAL_BYTE ){
            	LogUtil.setLogFileStart(batchDoc);
            }

            return true;

        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    /**
     * int getCalculatedLength(int idx)
     * --------------------------------------------------------------------------------------
     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
     */
    public int getCalculatedLength(int idx) {

        if (idx >= this.getFieldCount()) {
            logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI011";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        if (!this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        if ( idx == 6 ){
            return batchDoc.getBatchMsg().getHeader().getSequenceSize();
        }else{
            return 0;
        }
    }

    private boolean createFile ()
    {

        fin = BatchOpenFileManager.getInstance().getFile(batchDoc.getBatchMsg().getHeader().getUUID());
        if( fin != null ) return true;
        try {
            String fileDir = batchDoc.getBatchMsg().getHeader().getFilePath();
            String fileNm  = batchDoc.getBatchMsg().getHeader().getRenamedFileName();

            if (fileDir.charAt(fileDir.length()-1) != File.separatorChar) {
                fileDir = fileDir + File.separator;
            }

            String fileName = fileDir + fileNm;

            File file = new File(fileName);
            if (!file.exists()) // 파일이 없으면 리턴 False
            {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = fileName;
                String errCode = "BECEAIFJI022";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                throw new Exception(" the File["+fileName+"] does not exist!!!");
            }
            fin = new FileInputStream(file);
            BatchOpenFileManager.getInstance().addFile(batchDoc.getBatchMsg().getHeader().getUUID() , fileName, fin);
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI028";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }

    }

    private boolean setBlockAndSeqNO ()
    {
        try {
            if (!createFile()) {
                logger.error("{}  file open failed", logHeader);
                return false;
            }

            int block_size = this.batchDoc.getBatchMsg().getHeader().getBlockSize();
            SEQUENCE_NO    = this.batchDoc.getBatchMsg().getBody().getSeqNum() + 1;

            if (SEQUENCE_NO % block_size == 0) { //한 블럭 송신 후 결번확인(0300) 이후 데이터 전송
            	this.setConditionTxt(TelegramKeys.BLOCKEND);
            }
            
            // 한번에 보내는 길이
            int sequenceSize = batchDoc.getBatchMsg().getHeader().getSequenceSize();
            // 남은 바이트 수
            long remainSize = batchDoc.getBatchMsg().getHeader().getFileSize() - batchDoc.getBatchMsg().getBody().getCurFileSize();
            // 남은 건수

            boolean isLastSeq = false;
            if ( sequenceSize < remainSize ){
                REAL_BYTE = sequenceSize;
            }else{
                REAL_BYTE = (int)remainSize;
                this.setConditionTxt(TelegramKeys.BLOCKEND);
                isLastSeq = true;
            }

            fileData = new byte[REAL_BYTE];
            fin.read(fileData);

            if ( isLastSeq ){
                fin.close();
                BatchOpenFileManager.getInstance().removeFile(batchDoc.getBatchMsg().getHeader().getUUID());
            }

            // 파일에서 읽은 DATA를 추후 결번 재전송을 위해 메모리에 저장해 둔다. 2008.06.19 - 정동한
            JobProcessData job = JobProcessData.getInstance();
            String uuid = this.batchDoc.getBatchMsg().getHeader().getUUID();
            HashMap<String, Object> hm = job.getBatchStageData(uuid);

            @SuppressWarnings("unchecked")
            HashMap<Integer, byte[]> block_data = (HashMap<Integer, byte[]>) hm.get(JobProcessData.PROCDATA_BLOCKDATA);
            if (block_data == null) {
                block_data = new HashMap<Integer, byte[]>();
            }
            block_data.put( new Integer(SEQUENCE_NO - 1), fileData);
            hm.put(JobProcessData.PROCDATA_BLOCKDATA, block_data);
            // 2008.06.19 - 정동한

            this.batchDoc.getBatchMsg().getBody().setSeqNum(SEQUENCE_NO);

            return true;
        } catch (Exception e ) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI029";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    private boolean calculateSendLength () {
        try {
            for (int i=1; i< this.al_Field.size(); i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            SEND_LENGTH -= 2; // 전문레이아웃상 가변필드가 두개임
            SEND_LENGTH += getCalculatedLength(6);
            SEND_LENGTH += getCalculatedLength(9);
            REAL_SEND_LENGTH = SEND_LENGTH;
            REAL_SEND_LENGTH += ((byte[]) this.al_Field.get(0)).length;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(2);
    }

    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(3);
    }
}